### name of the executable that will be produced
PROG = mecca.exe

# complete list of all f90 source files
SRCS0 = $(wildcard *.f90)
SRCS  = $(filter-out F%.f90, $(SRCS0))

# the object files are the same as the source files but with suffix ".o"
OBJS := $(SRCS:.f90=.o)

MAKEFILE_INC = depend.mk

# If you don't have the perl script sfmakedepend, get it from:
# http://www.arsc.edu/~kate/Perl
F_makedepend = ./sfmakedepend --file=$(MAKEFILE_INC)

all: $(PROG)

ifeq ($(strip $(OUTPUT)), NETCDF)
link:
# with netcdf library:
	ln -fs mo_netcdf.f90-real mo_netcdf.f90
else
link:
# without netcdf library:
	ln -fs mo_netcdf.f90-ascii mo_netcdf.f90
	LLIBS=
endif

# the dependencies depend on the link
# the executable depends on depend and also on all objects
# the executable is created by linking all objects
$(PROG): link depend $(OBJS)
	$(F90) $(F90FLAGS) $(OBJS) $(LLIBS) -o $@

# update file dependencies
depend $(MAKEFILE_INC): $(SRCS)
	$(F_makedepend) $(SRCS)

# check files
list:
	@echo "SRCS = $(SRCS)"

# this command is executed by "gmake clean"
clean:
	rm -f $(OBJS) *.mod *.log *~

distclean: clean
	rm -f $(PROG)
	rm -f depend.mk* 
	rm -f *.nc
	rm -f *.dat

# all object files *.o depend on their source files *.f90
# the object files are created with the "-c" compiler option
%.o: %.f90
	$(F90) $(F90FLAGS) $(LINCLUDES) -c $<
