! --- Plain QSSA with fixed step size
!
      SUBROUTINE INTEGRATE( TIN, TOUT  ) 

      INCLUDE 'KPP_CRTFN.h'

! TIN - Start Time
      KPP_REAL TIN
! TOUT - End Time
      KPP_REAL TOUT

! Local variables
      KPP_REAL P_VAR(NVAR), D_VAR(NVAR)                    
      LOGICAL IsReject
      KPP_REAL T, Tnext, STEP, Told, SUP
      KPP_REAL ratio, tmp
      INTEGER i

      T = TIN
      Tnext = TOUT
      STEP = 0.1
      Told = T
      SUP  = 1e-14
      IsReject = .false.

! -- BELOW THIS LIMIT USE TAYLOR INSTEAD OF EXP ---

      do while ( T.lt.Tnext )   
   
        if ( T.gt.Tnext ) then
          STEP = Tnext - Told
          T = Tnext
        end if

        call FSPLIT_VAR ( VAR, RAD, P_VAR, D_VAR )

        do i=1,NVAR
          if ( abs(D_VAR(i)).gt.SUP ) then
            ratio = P_VAR(i)/D_VAR(i)
            tmp = exp(-D_VAR(i)*STEP)
            VAR(i) = tmp * (VAR(i) - ratio) + ratio
          else
            tmp = D_VAR(i) * STEP
            VAR(i) = VAR(i) + P_VAR(i) * 0.5 * STEP * ( 1 - 0.5 * tmp * &
                   ( 1 - 1.0 / 3.0 * tmp ) )
          end if
        end do

        T = T + STEP
        TIME = T

      end do

      END SUBROUTINE INTEGRATE
